(if (null rtd)
  (progn
    (defun dtr (N)
      (/(* n pi) 180.0)
    )
    (defun r12 ()
      (getvar "CMDNAMES")
    )
    (defun rtd (N)
      (/(* n 180.0) pi)
    )
  )
)

(defun gearbutton(n / rp ri ro rg)
  (getgear)
  (if (/= n 4)(setq x0 (- m(* z(EXPT(SIN(DTR a)) 2) 0.5 m))))
  (setq rp (* m z 0.5) ro(+ rp m x0) ri(+ rp(* -1.25 m) x0) rg(* rp(COS a)))
  (set_tile "od" (rtos (+ ro ro)))
  (set_tile "id" (rtos (+ ri ri)))
  (set_tile "x0" (rtos x0))
)
(defun getgear()
  (setq m (atof (get_tile "ms"))
        z (atoi (get_tile "tz"))
        a (atoi (get_tile "pa"))
        x0 (atof (get_tile "x0"))
        cx (atoi (get_tile "cx"))
        cy (atoi (get_tile "cy"))
        ro (/ (atof (get_tile "od")) 2.0)
        ri (/ (atof (get_tile "id")) 2.0)
        gap (atof (get_tile "gap"))
  )
)
(defun c:gear (/ po rp ri ro rg p1 p2 p3 p4 p5 p6 ap ao ai ss ab da fa i a4 x0)
  (lispset nil)
  (setq id (load_dialog (findfile "gear.dcl")))
  (setq m 2.0 z 16 a 20.0 x0 0)
  (new_dialog "gear" id)
  (set_tile "ms" "2.0")
  (set_tile "tz" "16")
  (set_tile "type" "0")
  (set_tile "pa" "20")
  (set_tile "x0" "0")
  (set_tile "cx" "0")
  (set_tile "cy" "0")
  (set_tile "gap" "0.0")
  (gearbutton 2)
  (action_tile "ms" "(gearbutton 1)")
  (action_tile "tz" "(gearbutton 2)")
  (action_tile "pa" "(gearbutton 3)")
  (action_tile "x0" "(gearbutton 4)")
  (action_tile "type" "(gearbutton 0)")
  (action_tile "accept" "(getgear)(done_dialog)")
  (if (start_dialog)
    (progn
      (osm 0)
      (setq po (list cx cy 0)a(/(* a pi) 180.0) ss(SSADD))
      (setq rp(* m z 0.5) rg(* rp(COS a)))
      (setq da(/ pi 2 z) fa(/(* rp(SIN a)) rg) ab(- a(+ fa da)(/(* x0(SIN a)) rg)))
      (if (> rg ri)
        (setq ap 0)
        (setq ap(/(SQRT(-(* ri ri)(* rg rg))) rg))	;򥻨
      )
      (setq i ap ao(/(SQRT(-(* ro ro)(* rg rg))) rg) ai(/(- ao ap) 5))
      (setq p4(polar po ab ri) p3(polar po 0 ro) p5(polar po(/(- 0 pi) z) ri))
      (if (/= ap 0)
        (setq p4(polar po(+ ap ab) rg) p4(polar p4(+ ab(- ap(/ pi 2)))(* rg ap)))
      )
      (setq pp9(polar po(-(/(- 0 pi) z 0.5)(angle po p4))(distance po p4)))
      (command ".zoom" "c" po(* 2.2 ro))
      (if (setq e0(entlast))(while (entnext e0)(setq e0 (entnext e0))))
      ;===================================================
      (command ".arc" pp9 "c" po p4)(setq e2 (entlast))
      (command ".pline")
      (if (> rg ri)(command p4))
      (repeat 6
        (setq p1(polar po (+ i ab) rg) p2 (polar p1(+ ab(- i(/ pi 2)))(- (* rg i) gap)))
        (command p2)
        (setq i(+ i ai))
      )
      (command "")
      (princ "0")
      (if (> rg ri)
        (command "pedit"(entlast) "e" "t"(RTD(angle po p4)) "n" "t"(RTD(angle po p4)) "x" "f" "e" "t" 0 "n" "t" 0 "x" "x")
        (command "pedit"(entlast) "f" "x")
      )(setq e3 (entlast))
      (command ".explode" e3 )
      (command ".mirror" (addss e2) "" po p3 "n")
      (setq a4(angle po p2) p6(polar po(- 0 a4) ro))
      (command ".arc" p2 "c" po p6)
      (command ".array" (addss e0) "" "p" po z "" "")
      (if e0
        (setq e0(entnext e0))
        (setq e0(entnext))
      )
      (setq p1 (polar po (dtr -135)(* ro 1.5)) p2 (polar po (dtr 45)(* ro 1.5)))
      (command ".pedit" e0 "y" "j" "w" (polar po (dtr -135)(* ro 1.5))(polar po (dtr 45)(* ro 1.5)) "" "X")
    )
  )
  (reset)
)
